{$APPTYPE CONSOLE}
program DynaTab5;
uses
  DB, DBTables;

const
  CalcFieldName = 'The Answer';

type
  TBTable = class(TTable)
    procedure CalcFields(DataSet: TDataSet);
  end;

  procedure TBTable.CalcFields(DataSet: TDataSet);
  begin
    DataSet[CalcFieldName] := 42
  end;

var
  Table: TBTable;
  CalcField: TFloatField;

begin
  Table := TBTable.Create(nil);
  try
    Table.DatabaseName := 'DBDEMOS';
    Table.TableName := 'BIOLIFE.DB';

    CalcField := TFloatField.Create(Table);
    CalcField.FieldName := CalcFieldName;
    CalcField.FieldKind := fkCalculated; { default = fkData }
    CalcField.DataSet := Table;

    Table.OnCalcFields := Table.CalcFields;

    Table.Open;
    writeln(CalcField.DisplayName,': ',CalcField.DisplayText);
    Table.Close

  finally
    CalcField.Free;
    Table.Free
  end
end.
