set nocount on
drop table SystemCodes
go
create table SystemCodes(
  codTable varchar(20), 
  codCode varchar(15),
  codDesc varchar(25),
  primary key (codTable, codCode)
)
go

insert SystemCodes values('EMPTYPE', 'Z', '<None>')
insert SystemCodes values('EMPTYPE', 'REG', 'Regular')
insert SystemCodes values('EMPTYPE', 'CON', 'Contractor/consultant')
insert SystemCodes values('EMPTYPE', 'INT', 'Intern')
insert SystemCodes values('EMPTYPE', 'STU', 'Student')
insert SystemCodes values('EMPTYPE', 'SUM', 'Summer help')
insert SystemCodes values('EMPTYPE', 'TMP', 'Temporary')

insert SystemCodes values('FULLORPARTTIME', 'F', 'Full time')
insert SystemCodes values('FULLORPARTTIME', 'P', 'Part time')

insert SystemCodes values('SALARYORHOURLY', 'S', 'Salaried')
insert SystemCodes values('SALARYORHOURLY', 'H', 'Hourly')
go

select * from systemcodes
  order by codTable, codCode
print ""


drop table QualifierFilters
go
create table QualifierFilters(
  qlfID smallint,
  qlfDescription varchar(25),
  qlfCodeTable varchar(20),
  qlfDataField varchar(40),  /* tablename.fieldname */
  primary key (qlfID)
)
go
insert QualifierFilters values (1, 'Hourly/salaried', 'SALARYORHOURLY', 'Employees.empSalaryOrHourly')
insert QualifierFilters values (2, 'Full time/part time', 'FULLORPARTTIME', 'Employees.empFullOrPartTime')
insert QualifierFilters values (3, 'Employee type', 'EMPTYPE', 'Employees.empType')
select * from QualifierFilters
print ""

go
drop table Qualifiers
go
create table Qualifiers(
  quaRecID int identity(1000,1),
  quaID smallint,
  quaFilterID smallint,
  quaCode varchar(20),
  primary key (quaRecID)
)
go
insert Qualifiers (quaID, quaFilterID, quaCode) values (100, 1, "H")
insert Qualifiers (quaID, quaFilterID, quaCode) values (100, 2, "F")
insert Qualifiers (quaID, quaFilterID, quaCode) values (100, 3, "REG")
go
select * from Qualifiers


